
Ruby - Bug #12339

result of 123456789 ** -2 in doc

05/02/2016 10:47 AM - znz (Kazuhiro NISHIYAMA)

Status: Closed   

Priority: Normal   

Assignee: znz (Kazuhiro NISHIYAMA)   

Target version:    

ruby -v: ruby 2.4.0dev (2016-05-02 trunk 54882)

[x86_64-darwin14]

Backport: 2.1: REQUIRED, 2.2: DONE, 2.3: DONE

Description

https://github.com/ruby/ruby/blob/c353ec0c9e8e941f49910a51f7dc10cf3d3cdd17/numeric.c#L3647

の Integer#** の rdoc で

 *    123456789 ** -2     #=> 6.5610001194102e-17

 となっていますが、実際に試してみると (1/15241578750190521) になります。

どちらが正しいのでしょうか?

%  ruby -ve 'p 123456789 ** -2'

ruby 2.4.0dev (2016-05-02 trunk 54882) [x86_64-darwin14]

(1/15241578750190521)

Associated revisions

Revision 8ef6dacb248876b444595a26ea78c35eb07a188b - 05/03/2016 02:31 PM - znz (Kazuhiro NISHIYAMA)

Update result of 123456789 ** -2

numeric.c: [DOC] Update result of 123456789 ** -2.

[ruby-dev:49606] [Bug #12339]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@54898 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 8ef6dacb - 05/03/2016 02:31 PM - znz (Kazuhiro NISHIYAMA)

Update result of 123456789 ** -2

numeric.c: [DOC] Update result of 123456789 ** -2.

[ruby-dev:49606] [Bug #12339]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@54898 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision ac5ffe0a19df7f373d699bce8a66f6154ad80182 - 05/05/2016 05:26 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 54898: [Backport #12339]

    * bignum.c: [DOC] Update result of 123456789 ** -2.

      [ruby-dev:49606] [Bug #12339]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@54922 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision ac5ffe0a - 05/05/2016 05:26 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 54898: [Backport #12339]

    * bignum.c: [DOC] Update result of 123456789 ** -2.

      [ruby-dev:49606] [Bug #12339]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@54922 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 1511ef08ef72e17f648599cf6fddc2ea6d17d27e - 06/10/2016 06:47 AM - U.Nakamura 

merge revision(s) 54898: [Backport #12339]

    * bignum.c: [DOC] Update result of 123456789 ** -2.

      [ruby-dev:49606] [Bug #12339]
https://github.com/ruby/ruby/blob/c353ec0c9e8e941f49910a51f7dc10cf3d3cdd17/numeric.c#L3647


 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@55350 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 1511ef08 - 06/10/2016 06:47 AM - U.Nakamura 

merge revision(s) 54898: [Backport #12339]

    * bignum.c: [DOC] Update result of 123456789 ** -2.

      [ruby-dev:49606] [Bug #12339]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@55350 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 05/03/2016 05:28 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Assigned

- Assignee set to znz (Kazuhiro NISHIYAMA)

- Backport changed from 2.1: UNKNOWN, 2.2: UNKNOWN, 2.3: UNKNOWN to 2.1: REQUIRED, 2.2: REQUIRED, 2.3: REQUIRED

1.9でRationalが組み込みになって動作が変わったはずです。

#2 - 05/03/2016 02:31 PM - Anonymous

- Status changed from Assigned to Closed

Applied in changeset r54898.

Update result of 123456789 ** -2

numeric.c: [DOC] Update result of 123456789 ** -2.

[ruby-dev:49606] [Bug #12339]

#3 - 05/03/2016 05:32 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.1: REQUIRED, 2.2: REQUIRED, 2.3: REQUIRED to 2.1: DONTNEED, 2.2: DONTNEED, 2.3: DONTNEED

該当する部分は r54831 で Fixnum/Bignum メソッドの統合時に書き加えられていて、ruby_2_3 以前のブランチの rdoc 用コメントには存在しませんでした。また 1 ** -2 の例は正しく (1/2)

の表記になっていました。

#4 - 05/04/2016 06:35 AM - znz (Kazuhiro NISHIYAMA)

- Backport changed from 2.1: DONTNEED, 2.2: DONTNEED, 2.3: DONTNEED to 2.1: REQUIRED, 2.2: REQUIRED, 2.3: REQUIRED

Bignum#** からのマージなので、ruby_2_3 以前のブランチでは rb_big_pow にあります。

#5 - 05/05/2016 05:26 PM - nagachika (Tomoyuki Chikanaga)

なるほどその通りでした。指摘ありがとうございます。

#6 - 05/05/2016 05:26 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.1: REQUIRED, 2.2: REQUIRED, 2.3: REQUIRED to 2.1: REQUIRED, 2.2: REQUIRED, 2.3: DONE

ruby_2_3 r54922 merged revision(s) 54898.

#7 - 06/10/2016 06:48 AM - usa (Usaku NAKAMURA)

- Backport changed from 2.1: REQUIRED, 2.2: REQUIRED, 2.3: DONE to 2.1: REQUIRED, 2.2: DONE, 2.3: DONE

ruby_2_2 r55350 merged revision(s) 54898.
